﻿commonModule.controller('taxReportCellDetailModalController', ['$log', 'apiInterceptor', 'Upload', '$scope', '$q', '$translate', '$uibModal', '$document', '$rootScope', 'SweetAlert', 'enums',
    'vatReportService', 'loginContext', 'vatSessionService', 'stdAccountService', 'vatCommonService', 'formulaService', 'KeyValueConfigService', 'modelConfigurationService', '$timeout', 'cellCommentService', 'modifiedReportCellService', 'commonWebService', 'dxDataGridService',
    function ($log, apiInterceptor, Upload, $scope, $q, $translate, $uibModal, $document, $rootScope, SweetAlert, enums, vatReportService, loginContext,
              vatSessionService, stdAccountService, vatCommonService, formulaService, KeyValueConfigService, modelConfigurationService, $timeout, cellCommentService, modifiedReportCellService, commonWebService, dxDataGridService) {

        var activeClass = 'active';
        $scope.currentUserName = loginContext.userName;
        $scope.tabType = 1;
        $scope.isWriteBackUpdate = false;
        $scope.projectYear = vatSessionService.year;
        $scope.projectPeriod = vatSessionService.month;
        //关闭数据源弹出框
        var hidePanel = function () {
            $scope.selectedDataSourceTabIndex = 1;

            $scope.tabType = 1;
            $('#taxReportCellDetailModal').hide('normal');
            $('#taxReportCellDetailModal #cellDetailConent').show();
            $scope.detail.items = [];
            //隐藏凭证范围弹出框
            $scope.closePropover();
        };

        $scope.$watch('detail.config.cellID', function () {
            if ($scope.detail.config != null && $scope.detail.config.cellID != null) {
                cellCommentService.getCellComments($scope.detail.config.cellID).success(function (op) {
                    if (op.result === true) {
                        $scope.remarks = op.data;
                    }
                });
            }
        });

        /******************单元格值修改*********************************/
        //打开修改单元格值弹出框
        $scope.openModifyCellDataDialog = function () {
            var parentElem = angular.element($document[0].querySelector('#modifyCellDataContainer'));
            var modalInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                templateUrl: 'modifyCellData.html',
                controller: modifyCellDataController,
                windowClass: 'modification-table',
                appendTo: parentElem,
                scope: $scope
            });
        };


        var modifyCellDataController = function ($scope) {
            $scope.modifyReportCellModel = {};
            $scope.modifyReportCellModel.originalValue = $scope.$parent.detail.cellInfo.modifiedReportCell ? $scope.$parent.detail.cellInfo.modifiedReportCell.originalValue : $scope.$parent.detail.cellInfo.value;
            $scope.modifyReportCellModel.col = $scope.$parent.detail.config.columnIndex;
            $scope.modifyReportCellModel.row = $scope.$parent.detail.config.rowIndex;
            $scope.modifyReportCellModel.reportId = $scope.$parent.detail.reportId;

            $scope.saveModification = function () {
                modifiedReportCellService.update($scope.modifyReportCellModel).success(function (ret) {
                    $scope.$parent.detail.cellInfo.modifiedReportCell = ret.data;
                    $scope.$parent.detail.cellInfo.value = $scope.modifyReportCellModel.value;
                    $scope.$parent.detail.cellInfo.money = $scope.modifyReportCellModel.value;
                    $rootScope.$broadcast('cellValueModified',
                        {
                            modifiedReportCell: ret.data
                        });
                    $scope.$dismiss({$value: 'cancel'});
                });
            };

            $scope.hide = function () {
                $scope.$dismiss({$value: 'cancel'});
            };
        };

        $scope.resetReportCell = function () {
            modifiedReportCellService.reset($scope.detail.cellInfo.modifiedReportCell.id).success(function () {
                $scope.detail.cellInfo.money = $scope.detail.cellInfo.modifiedReportCell.originalValue;
                $scope.detail.cellInfo.modifiedReportCell = null;
                $rootScope.$broadcast('cellValueReset',
                    {
                        row: $scope.detail.rowIndex,
                        col: $scope.detail.columnIndex,
                    });
            });
        };

        modifyCellDataController.$inject = ['$scope'];
        /******************End of 单元格值修改*********************************/

        /******************单元格备注*****************************/
        $scope.addCellComment = function (content) {
            var addingComment = {
                userId: loginContext.userId,
                cellDataId: $scope.detail.config.cellID,
                userName: loginContext.userName,
                comment: $scope.addingRemark,
            };
            cellCommentService.addCellComment(addingComment).success(function (op) {
                if (op.result === true) {
                    $scope.remarks.push(addingComment);
                    $scope.addingRemark = '';
                }
            });
        };

        $scope.addRemark = function () {
            var now = new Date();
            $scope.remarks.push({
                cellDataId: $scope.detail.config.cellID,
                userName: loginContext.userName,
                content: $scope.addingRemark,
            });
            $scope.addingRemark = '';
        };

        $scope.deleteComment = function (comment) {
            cellCommentService.deleteCellComment(comment.id).success(function () {
                var index = $scope.remarks.indexOf(comment);
                if (index !== -1) {
                    $scope.remarks.splice(index, 1);
                }
            });
        };

        $scope.openReplyBox = function (remark) {
            var now = new Date();
            swal({
                title: $translate.instant('cellCommentReply'),
                type: "input",
                confirmButtonText: $translate.instant('Confirm'),
                cancelButtonText: $translate.instant('Cancel'),
                showCancelButton: true,
                closeOnConfirm: true,
            }, function (inputValue) {
                if (inputValue === false) return false;
                if (inputValue === "") {
                    swal.showInputError($translate.instant('cellCommentReplyEmptyMsg'));
                    return false
                }
                $scope.$apply(function () {
                    var addingComment = {
                        userId: loginContext.userId,
                        cellDataId: $scope.detail.config.cellID,
                        userName: loginContext.userName,
                        replyToUserName: remark.userName,
                        comment: inputValue,
                    };

                    cellCommentService.addCellComment(addingComment).success(function (op) {
                        if (op.result === true) {
                            $scope.remarks.push(addingComment);
                        }
                    });
                });

                return true;
            });
        };
        /***********************end of 单元格备注**********************/
            //展开|收起数据源弹出框
        var togglePanel = function () {

                if ($('#taxReportCellDetailModal #cellDetailConent').css('display') == 'none') {
                    $('#taxReportCellDetailModal').height(700);
                } else {
                    $('#taxReportCellDetailModal').height(40);
                }
                $timeout(function () {
                    $('#taxReportCellDetailModal #cellDetailConent').toggle('normal');
                    $('#taxReportCellDetailModal').height();
                    $scope.isExpand = !$scope.isExpand;
                }, 50)
            };

        function doConfirmEventHandler() {
            var r = /^00\d*|^\.\d+|\.$/;

            // if ($scope.detail.inputValue && parseFloat($scope.detail.inputValue).toFixed(2) > 9999999999999) {
            //     SweetAlert.warning($translate.instant('CheckInputValueLength'));
            //     return;
            // }
            if ($scope.detail.dataType === 5) {
                r = /^(-[1-9]\d*|[1-9]\d*|[0]{1,1})$/;
                if (!r.test($scope.detail.inputValue)) {
                    SweetAlert.warning($translate.instant('CheckIntInputValue'));
                    return;
                }
            }
            if ($scope.detail.inputMemo && $scope.detail.inputMemo.length > 500) {
                SweetAlert.warning($translate.instant('CheckInputMemoLength'));
                return;
            }
            if ($scope.detail.inputMemo && !$scope.detail.inputValue) {
                $scope.detail.inputValue = 0;
            }
            if (!$scope.detail.inputValue) {
                $scope.detail.inputValue = "0";
            }


            if ($scope.detail.inputValue && ((isNaN($scope.detail.inputValue) || r.test($scope.detail.inputValue))
                || parseFloat($scope.detail.inputValue).toFixed(2) > 9999999999999)) {
                // $scope.detail.inputValue;
                $scope.detail.keyinData = $scope.detail.inputValue;
            } else {
                $scope.detail.inputValue = $scope.detail.dataType === 5 ?
                    parseInt($scope.detail.inputValue) :
                    parseFloat($scope.detail.inputValue).toFixed(2);
            }

            $scope.onConfirm();

            var status = vatSessionService.project.projectStatusList[vatSessionService.month];
            //已生成，已提交=>原状态
            if (_.isEqual(vatSessionService.project.projectStatusList[vatSessionService.month], constant.ProjectStatusEnum.Generated) ||
                _.isEqual(vatSessionService.project.projectStatusList[vatSessionService.month], constant.ProjectStatusEnum.ReportSubmitted)) {

                status = vatSessionService.project.projectStatusList[vatSessionService.month];
            }

            //已审核及后续状态=>已生成
            if (vatSessionService.project.projectStatusList[vatSessionService.month] >= constant.ProjectStatusEnum.ReportApproved) {

                status = constant.ProjectStatusEnum.Generated;
            }
            $scope.hidePanel();
            vatCommonService.setProjectStatus(vatSessionService.project.id, vatSessionService.month, status, null, null);
        };


        //确定点击事件的处理函数
        var confirmEventHandler = function () {
            if (vatSessionService.project.projectStatusList[vatSessionService.month] >= constant.ProjectStatusEnum.AccountMapSubmitted) {
                swal({
                        title: "warning!",
                        text: $translate.instant('IsConfirmSaveReport').formatObj({status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[vatSessionService.month])}),
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Yes'),
                        cancelButtonText: $translate.instant('No'),
                        closeOnConfirm: true,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            var message;
                            var r = /^00\d*|^\.\d+|\.$/;
                            // if ($scope.detail.inputValue && (isNaN($scope.detail.inputValue) || r.test($scope.detail.inputValue))) {
                            //     message = $translate.instant('CheckInputValueFormat');
                            // } else
                            //     if ($scope.detail.inputValue && parseFloat($scope.detail.inputValue).toFixed(2) > 9999999999999) {
                            //     message = $translate.instant('CheckInputValueLength');
                            // } else
                            if ($scope.detail.dataType === 5) {
                                r = /^(-[1-9]\d*|[1-9]\d*|[0]{1,1})$/;
                                if (!r.test($scope.detail.inputValue)) {
                                    message = $translate.instant('CheckIntInputValue');
                                }
                            }
                            if ($scope.detail.inputMemo && $scope.detail.inputMemo.length > 500) {
                                message = $translate.instant('CheckInputMemoLength');
                            }
                            if (message) {
                                setTimeout(function () {
                                    swal({
                                        title: "warning!",
                                        text: message,
                                        type: "warning",
                                        showCancelButton: false,
                                        confirmButtonColor: "#DD6B55",
                                        confirmButtonText: '确认',
                                        closeOnConfirm: true
                                    }, function (isConfirm) {
                                        if (isConfirm) {
                                            return;
                                        }
                                    })
                                }, 500);
                            } else {
                                doConfirmEventHandler();
                            }
                        }
                        else {
                            swal.close();
                        }
                    });
            } else {
                doConfirmEventHandler();
            }
        };

        //切换数据源tab时执行
        var changeTabColor = function (type, typeId, typeName, operationType) {
            $scope.detail.cellType = type;
            $scope.detail.cellTypeId = typeId;
            $scope.selectedTabIndex = type;
            $scope.selectedTabId = typeId;
            $scope.selectedTypeName = typeName;
            $scope.currentOperationType = operationType;
            $($scope.detail.items).each(function (index, element) {
                if (element.type === type && (!typeId || typeId == element.id) &&
                    (element.type !== enums.formulaDataSourceType.OutputInvoice &&
                        element.type !== enums.formulaDataSourceType.Voucher &&
                        element.type !== enums.formulaDataSourceType.Special ||
                        typeName === element.name)) {
                    $scope.detail.dataGridSource = element.dataSource;

                    // TODO: Justify IF
                    //if (element.name === 'MaxConditionDataSource') {
                    //    $scope.dataSourceOptions.summary.totalItems[4].summaryType = 'max';
                    //} else {
                    //    $scope.dataSourceOptions.summary.totalItems[4].summaryType = 'min';
                    //}

                    return;
                }
            });
        };

        // 如果公式数据源为销项发票或凭证，该数据源可能是未开票数据源，
        // 这两类公式数据源可能会同时存在多个tab，判断时要加上Name作为判断条件
        var checkIfSelectedTab = function (tabIndex, item) {
            var rtn = false;
            if (tabIndex === 1) { // 非手工数据源
                rtn = $scope.selectedTabIndex === item.type &&
                    $scope.selectedDataSourceTabIndex === 1 &&
                    $scope.selectedTabId === item.id &&
                    (item.type !== enums.formulaDataSourceType.OutputInvoice &&
                        item.type !== enums.formulaDataSourceType.Voucher &&
                        item.type !== enums.formulaDataSourceType.Special ||
                        $scope.selectedTypeName === item.name);
            } else if (tabIndex === 2) { // 手工数据源
                rtn = $scope.selectedDataSourceTabIndex == 2 ||
                    ($scope.detail.dataSourceCount == 1 && $scope.detail.hasKeyIn);
            }

            return rtn;
        };

        var changeVisibleDataSourceContainer = function (num) {
            $scope.selectedDataSourceTabIndex = num;
        };

        //---------------------------凭证范围-------------------------//start
        $scope.formulaList = [];
        $scope.keyValueList = [];
        $scope.accountDataSource = [];
        $scope.selectedAccount = [];
        $scope.selectedAccountCodes = [];
        $scope.selectedAccountTemp = [];
        //凭证范围grid设置。
        var voucherRangeOptions = {
            paging: {
                enabled: false
            },
            bindingOptions: {
                dataSource: {
                    deep: false,
                    dataPath: 'selectedAccount'
                }
            },
            height: 140,
            columns: [
                {caption: $translate.instant('KjSubjectCodeCol'), dataField: 'code', alignment: 'left'},
                {caption: $translate.instant('KjSubjectNameCol'), dataField: 'name', alignment: 'left'},
                {caption: $translate.instant('SubjectDirectionCol'), dataField: 'directionName', alignment: 'left'},
                {caption: $translate.instant('SubjectTypeCol'), dataField: 'acctPropName', alignment: 'left'},
                {
                    alignment: 'center',
                    width: '60px',
                    caption: $translate.instant('BtnDelete'),
                    cellTemplate: function (container, options) {
                        $('<a/>').addClass('dx-link dx-link-delete')
                            .html('<i class="fa fa-trash" aria-hidden="true"></i>')
                            .on('dxclick', function () {
                                options.component.removeRow(options.rowIndex);
                            })
                            .appendTo(container);
                    }
                }
            ],
            customizeColumns: function (columns) {
                $.each(columns, function (_, element) {
                    //定义表头的模板
                    element.headerCellTemplate = function (header, info) {
                        $('<span>').html(info.column.caption).appendTo(header);
                        $(header).parent().css({'color': '#444', 'background-color': '#fdd', 'font-family': '微软雅黑'})
                            .parent().css('border', '1px #ccc solid');
                    };
                });
            },
            columnAutoWidth: true,
            showBorders: true,
            showRowLines: true,
            showColumnLines: true,
            allowColumnResizing: true,
            hoverStateEnabled: true
        };

        //关闭凭证范围弹出框
        var closePropover = function () {
            $('.tab-add-voucher-area').popover('hide');
            $('.add-voucher-range-propover').hide();
            $scope.selectedAccount = $scope.selectedAccountTemp;
            $scope.selectedAccountCodes = _.pluck($scope.selectedAccount, 'code');
        };

        //打开凭证范围弹出框
        var openAcctPropover = function () {
            $('.add-voucher-range-propover').show();
            $scope.selectedAccount = $scope.selectedAccountTemp;
        }

        //保存新的凭证范围。
        var voucherRangeConfirm = function () {
            var keyValue = '';
            var newStdAccountCodes = _.map($scope.selectedAccount, function (item) {
                return item.code;
            }).join(',');
            keyValue = newStdAccountCodes;
            if ($scope.voucherRange.filterWay == '2') {
                keyValue = $scope.voucherRange.voucherKeyword;
            }
            vatReportService
                .updateCellAccountRangeAndSummary($scope.detail.cellTemplateId, vatSessionService.month, keyValue, $scope.voucherRange.filterWay)
                .success(function () {
                    if ($scope.voucherRange.filterWay == '2') {
                        $scope.selectedAccount = [];
                        $scope.selectedAccountCodes = [];
                    } else {
                        $scope.voucherRange.voucherKeyword = '';
                        $scope.selectedAccountTemp = $scope.selectedAccount;
                    }
                    $scope.closePropover();
                });
        };

        // 刷新选中的过滤凭证科目代码
        var refreshVoucherFilter = function () {
            if (!$scope.selectedAccountCodes) {
                $scope.selectedAccountCodes = [];
            }

            if (!_.isEmpty($scope.selectedAccountCodes)) {
                var selectedData = _.filter($scope.accountDataSource, function (data) {
                    return $scope.selectedAccountCodes.indexOf(data.code) > -1;
                });

                $scope.selectedAccount = selectedData;
            } else {
                $scope.selectedAccount = [];
            }
        };

        // 设置科目代码选择器
        $scope.accountTitle = $translate.instant('AddAccount');
        $scope.accountSelectorOptions = {
            height: 500,
            top: 140,
            width: 730
        };
        $scope.accountSelectorApi = {
            onSelectorConfirm: refreshVoucherFilter
        };
        var showSelectAccountPop = function () {
            $scope.isShowAccounts = true;
        };

        //--------------------------凭证范围-----------------------------//end

        //删除所有凭证|发票筛选
        var removeVoucherFilterTab = function (event) {
            if (event.target.tagName.toLowerCase() === 'span') {
                SweetAlert.swal({
                    title: $translate.instant('ConfirmDelete'),
                    text: '',
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Confirm'),
                    cancelButtonText: $translate.instant('Cancel'),
                    closeOnConfirm: true
                }, function (isConfirm) {
                    if (isConfirm) {
                        //获取当前要删除的筛选类型
                        var currentType = $(event.target).parent().attr('data-type');
                        var currentTypeId = $(event.target).parent().attr('data-type-id');
                        var tempDetailItems = _.filter($scope.detail.items, function (sourceItem) {
                            return sourceItem.type != currentType || sourceItem.id != currentTypeId
                        });

                        var deleteService = currentType == $scope.ModelDatasource ? modelConfigurationService.deleteModelBackFill : vatReportService[vatSessionService.citFlag === "cit" ? "citDeleteCellDatasource" : "deleteCellDatasource"];

                        deleteService(currentTypeId, $scope.detail.config.cellID).success(function (rst) {
                            SweetAlert.swal({
                                title: $translate.instant(rst.result ? "DeleteSuccess" : rst.resultMsg),
                                text: '',
                                type: "warning",
                                confirmButtonColor: "#DD6B55",
                                confirmButtonText: $translate.instant('Confirm'),
                                closeOnConfirm: true
                            });

                            if (rst.result) {
                                if (currentType == $scope.ModelDatasource) {
                                    //通知父层去更新 数据
                                    $scope.$emit("hasModelWriteBackUpdated", {isupdated: true});
                                }
                                else {
                                    if (currentType == $scope.VoucherFilter || currentType == $scope.InvoiceFilter) {
                                        _.each($scope.detail.items, function (item) {
                                            if (item.type == currentType && item.id === currentTypeId) {
                                                item.dataSource = [];
                                            }
                                        });
                                    }

                                    var tabContainer = $(event.target).closest(".tab-container");
                                    $(event.target).closest(".tab").remove();

                                    var firstTab = tabContainer.find(".tab:eq(0)");
                                    if (firstTab.length > 0) {
                                        var tabIndex = firstTab.attr('data-tab-index');
                                        var dataType = firstTab.attr('data-type');
                                        var dataTypeId = firstTab.attr('data-type-id');
                                        var dataTypeName = firstTab.attr('data-type-name');
                                        if (dataType !== undefined) {
                                            $scope.selectedTabIndex = parseInt(dataType);
                                            $scope.selectedTabId = dataTypeId;
                                            $scope.selectedTypeName = dataTypeName;
                                            $scope.detail.cellType = parseInt(dataType);
                                            $scope.detail.cellTypeId = dataTypeId;
                                        }
                                        $scope.selectedDataSourceTabIndex = parseInt(tabIndex);
                                    } else {
                                        $scope.detail.cellType = 0;
                                    }
                                    $scope.detail.dataSourceCount--;
                                    $scope.detail.items = tempDetailItems;
                                }
                            }
                        });
                    }
                });
            }
        };

        //设置数据源表格的合计与表格高度
        function setSummaryColumnAndHeight() {
            $timeout(function () {
                $("#dataSourceGrid .dx-datagrid-total-footer").hide();
                $scope.dataSourceOptions.width = '100%';
                if ($scope.selectedTabIndex != enums.formulaDataSourceType.KeyInSource &&
                    $scope.selectedTabIndex != enums.formulaDataSourceType.RuleSource &&
                    $scope.selectedTabIndex != enums.formulaDataSourceType.Special) {
                    $("#dataGridFooterSummary").show();
                    $scope.dataGridHeight = 165;

                } else {
                    $("#dataGridFooterSummary").hide();
                    $scope.dataGridHeight = 195;
                }
            }, 100);
        }

        var dataGridCommonOptions = {
            bindingOptions: {
                columns: 'dataGridColumns',
                dataSource: 'detail.dataGridSourceBind',
                height: 'dataGridHeight'
            },
            //添加合计（dx的合计行隐藏，用重写合计行替代，fixed bug 10941）
            summary: {
                totalItems: [{
                    column: 'reportColumn',
                    displayFormat: $translate.instant('Conclusion')
                }, {
                    column: 'cellName',
                    customizeText: function (data) {
                        $("#dataSourceGrid .dx-datagrid-total-footer").hide();
                        if ($scope.detail.cellType == enums.formulaDataSourceType.TrialBalanceSource) {
                            return $scope.detail.cellInfo.money;
                        }
                        return $scope.detail.summaryExp;
                    }
                }, /*{
                    column: 'cellValue',
                    summaryType: 'sum',
                    customizeText: function (data) {
                        
                    }
                },*/ {
                    column: 'cellConditionName',
                    customizeText: function (data) {
                        $("#dataSourceGrid .dx-datagrid-total-footer").hide();
                        if ($scope.detail.cellType == enums.formulaDataSourceType.TrialBalanceSource) {
                            return $scope.detail.cellInfo.money;
                        }
                        return $scope.detail.summaryExp;
                    }
                }]
            },
            paging: {
                enabled: false
            },
            showBorders: true,
            showRowLines: true,
            showColumnLines: true,
            allowColumnResizing: true,
            //columnAutoWidth: true,
            hoverStateEnabled: true
        };

        var getConclusionVal = function () {
            var precition = 2;
            //如果数值是份数类型，则精度为0，否则为2
            if ($scope.detail.dataType === 5) {
                precition = 0;
            }
            var summaryValue = $scope.detail.summaryValue;
            var isShowCellNameSummary = $scope.detail.showFormulaSummary;
            if ((typeof summaryValue) === "string")
                summaryValue = summaryValue.replace("--", "- -").replace("++", "+ +");

            var evalVal = 0;
            var evalTaxVal = 0;
            try {
                evalVal = eval(summaryValue);
                if (!_.isNaN(evalVal)) {
                    evalVal = Number(evalVal);
                }
                else {
                    evalVal = 0;
                }
            }
            catch (ex) {

            }

            if ($scope.selectedTabIndex === enums.formulaDataSourceType.InputInvoice
                || $scope.selectedTabIndex === enums.formulaDataSourceType.InputInvoiceDetail
                || $scope.selectedTabIndex === enums.formulaDataSourceType.OutputInvoice
                || $scope.selectedTabIndex === enums.formulaDataSourceType.InvoiceFilter) {
                if(new Number($scope.detail.cellTemplateId)<0){
                    $("#dataGridFooterSummary").html("");
                }else{
                    evalVal = _.reduce($scope.detail.dataGridSource, function (memo, x) {
                        if(x.money){
                            return memo + x.money;
                        }else if(x.amount){
                            return memo + x.amount;
                        }else{
                            return memo;
                        }

                    }, 0);

                    evalTaxVal = _.reduce($scope.detail.dataGridSource, function (memo, x) {
                        if(x.taxMoney){
                            return memo + x.taxMoney;
                        }else if(x.taxAmount){
                            return memo + x.taxAmount;
                        }else{
                            return memo;
                        }
                    }, 0);
                    $("#dataGridFooterSummary").html($translate.instant('Conclusion')
                        + '&nbsp;&nbsp;&nbsp;&nbsp;' + $translate.instant('Amount') + ':&nbsp;&nbsp;&nbsp;&nbsp;'
                        + evalVal.formatAmount(precition) + '&nbsp;&nbsp;&nbsp;&nbsp;' + $translate.instant('TaxAmount')
                        + ':&nbsp;&nbsp;&nbsp;&nbsp;' + evalTaxVal.formatAmount(precition));
                }
            }
            else if ($scope.selectedTabIndex === enums.formulaDataSourceType.Voucher) {
                evalVal = _.reduce($scope.detail.dataGridSource, function (memo, x) {
                    return memo + x.debit - x.credit;
                }, 0);
                $("#dataGridFooterSummary").html($translate.instant('Conclusion')
                    + '&nbsp;&nbsp;&nbsp;&nbsp;' + evalVal.formatAmount(precition));
            }
            else if ($scope.selectedTabIndex === enums.formulaDataSourceType.VoucherFilter) {
                evalVal = _.reduce($scope.detail.dataGridSource, function (memo, x) {
                    return memo + x.debitAmount - x.creditAmount;
                }, 0);
                $("#dataGridFooterSummary").html($translate.instant('Conclusion')
                    + '&nbsp;&nbsp;&nbsp;&nbsp;' + evalVal.formatAmount(precition));
            }
            //else if ($scope.selectedTabIndex === enums.formulaDataSourceType.BSPL) {
            //    evalVal = _.reduce($scope.detail.dataGridSource, function (memo, x) {
            //        return memo + x.amount;
            //    }, 0);
            //    $("#dataGridFooterSummary").html($translate.instant('Conclusion')
            //        + '&nbsp;&nbsp;&nbsp;&nbsp;' + evalVal.formatAmount(precition));
            //}
            else if ($scope.selectedTabIndex === enums.formulaDataSourceType.ModelDatasource) {
                evalVal = _.reduce($scope.detail.dataGridSource, function (memo, x) {
                    return memo + x.cellValue;
                }, 0);
                $("#dataGridFooterSummary").html($translate.instant('Conclusion')
                    + '&nbsp;&nbsp;&nbsp;&nbsp;' + evalVal.formatAmount(precition));
            }
            else { // For 报表数据源 and BSPL数据源

                if ($scope.detail.dataGridSource && $scope.detail.dataGridSource.length > 0) {
                    //判断是否是动态生成sheet
                    // if(new Number($scope.detail.cellTemplateId)<0){
                    //     $("#dataGridFooterSummary").html("");
                    // }else{
                    //     evalVal = _.reduce($scope.detail.dataGridSource, function (memo, x) {
                    //         return memo + x.cellValue;
                    //     }, 0);
                    //     $("#dataGridFooterSummary").html($translate.instant('Conclusion') +
                    //         '&nbsp;&nbsp;&nbsp;&nbsp;' + evalVal.formatAmount(precition));
                    // }
                    $("#dataGridFooterSummary").html("");


                }
                else {
                    var summaryExp = '';
                    if (isShowCellNameSummary && !_.isEmpty($scope.detail.summaryExp)
                        && $scope.detail.summaryExp.indexOf('DS[') < 0) { // 在Demo中，去掉结论中的未替换表达式
                        summaryExp = '&nbsp;&nbsp;&nbsp;&nbsp;' + $scope.detail.summaryExp;
                    }
                    $("#dataGridFooterSummary").html($translate.instant('Conclusion') + summaryExp +
                        '&nbsp;&nbsp;&nbsp;&nbsp;' + evalVal.formatAmount(precition));
                }
            }

            setSummaryColumnAndHeight();
            return evalVal.formatAmount(precition);
        };

        //设置数据源表格的列
        var getDataGridColumns = function () {
            var dataGridColumns;
            switch ($scope.detail.cellType) {
                case enums.formulaDataSourceType.TrialBalanceSource:
                    //平衡表数据源
                    dataGridColumns = [
                        {
                            calculateCellValue: function () {
                                return $scope.projectPeriod
                            },
                            // dataField: 'projectPeriod',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '10%'
                        },
                        {
                            calculateCellValue: function () {
                                var formula = $scope.detail.config.formula;
                                if (formula.indexOf('DFFS') > -1) {
                                    return '贷方发生';
                                } else if (formula.indexOf('JFFS') > -1) {
                                    return '借方发生';
                                }
                                return '';
                            },
                            // dataField: 'type',
                            caption: $translate.instant('类型'),
                            alignment: 'center',
                            width: '30%'
                        },
                        {
                            calculateCellValue: function () {
                                var formula = $scope.detail.config.formula;
                                return formula.match(/\"\d+\"/);
                            },
                            // dataField: 'description',
                            caption: $translate.instant('描述'),
                            alignment: 'center',
                            width: '30%'
                        },
                        {
                            calculateCellValue: function () {
                                return $scope.detail.cellInfo.money;

                            },
                            // dataField: 'value',
                            caption: $translate.instant('数值'),
                            alignment: 'center',
                            width: '30%'
                        }
                    ];
                    break;
                case enums.formulaDataSourceType.WPSR:
                    //平衡表数据源
                    dataGridColumns = [
                        {
                            calculateCellValue: function () {
                                return $scope.projectPeriod
                            },
                            // dataField: 'projectPeriod',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '10%'
                        },
                        {
                            calculateCellValue: function () {
                                return '无票收入';
                            },
                            // dataField: 'type',
                            caption: $translate.instant('类型'),
                            alignment: 'center',
                            width: '30%'
                        },
                        {
                            calculateCellValue: function () {
                                return '';
                            },
                            // dataField: 'description',
                            caption: $translate.instant('描述'),
                            alignment: 'center',
                            width: '30%'
                        },
                        {
                            calculateCellValue: function () {
                                return $scope.detail.cellInfo.money;

                            },
                            // dataField: 'value',
                            caption: $translate.instant('数值'),
                            alignment: 'center',
                            width: '30%'
                        }
                    ];
                    break;
                case enums.formulaDataSourceType.InputInvoice:
                    //进项数据源
                    dataGridColumns = [
                        {
                            calculateCellValue: function () {
                                return $scope.projectPeriod
                            },
                            // dataField: 'projectPeriod',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '10%'
                        },
                        {
                            calculateCellValue: function () {
                                return '进项发票';
                            },
                            // dataField: 'type',
                            caption: $translate.instant('类型'),
                            alignment: 'center',
                            width: '30%'
                        },
                        {
                            calculateCellValue: function () {
                                return '';
                            },
                            // dataField: 'description',
                            caption: $translate.instant('描述'),
                            alignment: 'center',
                            width: '30%'
                        },
                        {
                            calculateCellValue: function () {
                                return $scope.detail.cellInfo.money;

                            },
                            // dataField: 'value',
                            caption: $translate.instant('数值'),
                            alignment: 'center',
                            width: '30%'
                        }
                        // {
                        //     dataField: 'date',
                        //     caption: $translate.instant('InvoiceRZRQ'),
                        //     alignment: 'left',
                        //     width: '13%'
                        // },
                        // {
                        //     dataField: 'invoiceCode',
                        //     caption: $translate.instant('InvoiceFPDM'),
                        //     alignment: 'left',
                        //     width: '13%'
                        // },
                        // {
                        //     dataField: 'invoiceNumber',
                        //     caption: $translate.instant('InvoiceFPHM'),
                        //     alignment: 'left',
                        //     width: '13%'
                        // },
                        // {
                        //     dataField: 'saleId',
                        //     caption: $translate.instant('InvoiceXFSBH'),
                        //     alignment: 'left',
                        //     width: '13%'
                        // },
                        // {
                        //     dataField: 'money',
                        //     caption: $translate.instant('InvoiceJE'),
                        //     alignment: 'right',
                        //     format: {type: 'fixedPoint', precision: 2},
                        //     width: '13%'
                        // },
                        // {
                        //     dataField: 'taxMoney',
                        //     caption: $translate.instant('InvoiceSE'),
                        //     alignment: 'right',
                        //     format: {type: 'fixedPoint', precision: 2},
                        //     width: '13%'
                        // },
                        // {
                        //     dataField: 'invoiceType',
                        //     caption: $translate.instant('InvoiceFPLX'),
                        //     alignment: 'left',
                        //     width: '13%'
                        // }
                    ];
                    break;
                case enums.formulaDataSourceType.InputInvoiceDetail:
                    //进项明细数据源
                    dataGridColumns = [
                        {
                            dataField: 'period',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '9%'
                        },
                        {
                            dataField: 'date',
                            caption: $translate.instant('InvoiceKPRQ'),
                            alignment: 'left',
                            width: '13%'
                        },
                        {
                            dataField: 'invoiceCode',
                            caption: $translate.instant('InvoiceFPDM'),
                            alignment: 'left',
                            width: '13%'
                        },
                        {
                            dataField: 'invoiceNumber',
                            caption: $translate.instant('InvoiceFPHM'),
                            alignment: 'left',
                            width: '13%'
                        },
                        {
                            dataField: 'money',
                            caption: $translate.instant('InvoiceJE'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2},
                            width: '13%'
                        },
                        {
                            dataField: 'taxRate',
                            caption: $translate.instant('InvoiceSL'),
                            alignment: 'left',
                            width: '13%'
                        },
                        {
                            dataField: 'taxMoney',
                            caption: $translate.instant('InvoiceSE'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2},
                            width: '13%'
                        },
                        {
                            dataField: 'cargoName',
                            caption: $translate.instant('InvoiceHWMC'),
                            alignment: 'left',
                            width: '13%'
                        }
                    ];
                    break;
                case enums.formulaDataSourceType.OutputInvoice:
                    //销项发票数据源
                    dataGridColumns = [
                        {
                            calculateCellValue: function () {
                                return $scope.projectPeriod
                            },
                            // dataField: 'projectPeriod',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '10%'
                        },
                        {
                            calculateCellValue: function () {
                                return '销项发票';
                            },
                            // dataField: 'type',
                            caption: $translate.instant('类型'),
                            alignment: 'center',
                            width: '30%'
                        },
                        {
                            calculateCellValue: function () {
                                return '';
                            },
                            // dataField: 'description',
                            caption: $translate.instant('描述'),
                            alignment: 'center',
                            width: '30%'
                        },
                        {
                            calculateCellValue: function () {
                                return $scope.detail.cellInfo.money;

                            },
                            // dataField: 'value',
                            caption: $translate.instant('数值'),
                            alignment: 'center',
                            width: '30%'
                        }/*
                        {
                            dataField: 'period',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '8%'
                        },
                        {
                            dataField: 'date',
                            caption: $translate.instant('InvoiceKPRQ'),
                            alignment: 'left',
                            width: '11%'
                        },
                        {
                            dataField: 'acquiringEnterprise',
                            caption: $translate.instant('BuyerName'),
                            alignment: 'left',
                            width: '13%'
                        },
                        {
                            dataField: 'invoiceCode',
                            caption: $translate.instant('InvoiceFPDM'),
                            alignment: 'left',
                            width: '11%'
                        },
                        {
                            dataField: 'invoiceNumber',
                            caption: $translate.instant('InvoiceFPHM'),
                            alignment: 'left',
                            width: '13%'
                        },
                        {
                            dataField: 'money',
                            caption: $translate.instant('InvoiceJE'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2},
                            width: '11%'
                        },
                        {
                            dataField: 'taxRate',
                            caption: $translate.instant('InvoiceSL'),
                            alignment: 'left',
                            width: '11%'
                        },
                        {
                            dataField: 'taxMoney',
                            caption: $translate.instant('InvoiceSE'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2},
                            width: '11%'
                        },
                        {
                            dataField: 'invoiceType',
                            caption: $translate.instant('InvoiceType'),
                            alignment: 'left',
                            width: '11%'
                        }*/
                    ];
                    break;
                case enums.formulaDataSourceType.Voucher:
                    //凭证数据源
                    dataGridColumns = [
                        {
                            dataField: 'period',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '10%'
                        },
                        {
                            dataField: 'voucherDate',
                            caption: $translate.instant('VoucherDate'),
                            alignment: 'left',
                            width: '15%'
                        },
                        {
                            dataField: 'acctCode',
                            caption: $translate.instant('EntempriseAccount'),
                            alignment: 'left',
                            width: '15%'
                        },
                        {
                            dataField: 'voucherID',
                            caption: $translate.instant('VoucherCode'),
                            alignment: 'left',
                            width: '15%'
                        },
                        {
                            dataField: 'summary',
                            caption: $translate.instant('VoucherSummary'),
                            alignment: 'left',
                            width: '15%'
                        },
                        {
                            dataField: 'debit',
                            caption: $translate.instant('DebitAmount'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2},
                            width: '15%'
                        },
                        {
                            dataField: 'credit',
                            caption: $translate.instant('CreditAmount'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2},
                            width: '15%'
                        }
                    ];
                    break;
                case enums.formulaDataSourceType.VoucherFilter:
                    //凭证筛选
                    dataGridColumns = [
                        {
                            dataField: 'period',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '9%'
                        },
                        {
                            dataField: 'date',
                            caption: $translate.instant('VoucherDate'),
                            alignment: 'left',
                            width: '13%'
                        },
                        {
                            dataField: 'enterpriseAccounting',
                            caption: $translate.instant('EntempriseAccount'),
                            alignment: 'left',
                            width: '13%'
                        },
                        {
                            dataField: 'voucherNumber',
                            caption: $translate.instant('VoucherCode'),
                            alignment: 'left',
                            width: '13%'
                        },
                        {
                            dataField: 'voucherSammary',
                            caption: $translate.instant('VoucherSummary'),
                            alignment: 'left',
                            width: '13%'
                        },
                        {
                            dataField: 'debitAmount',
                            caption: $translate.instant('DebitAmount'),
                            alignment: 'right',
                            width: '13%',
                            format: {type: 'fixedPoint', precision: 2}
                        },
                        {
                            dataField: 'creditAmount',
                            caption: $translate.instant('CreditAmount'),
                            alignment: 'right',
                            width: '13%',
                            format: {type: 'fixedPoint', precision: 2}
                        },
                        {
                            dataField: 'operate',
                            caption: $translate.instant('Operate'),
                            alignment: 'center',
                            width: '13%',
                            cellTemplate: function (element, info) {
                                $('<span>').css('cursor', 'pointer').html('<i class="fa fa-trash delete-icon" style="color: red;" role="button" tabindex="0" />').appendTo(element);
                                $(element).click(function () {
                                    SweetAlert.swal({
                                        title: $translate.instant('ConfirmDelete'),
                                        text: '',
                                        type: "warning",
                                        showCancelButton: true,
                                        confirmButtonColor: "#DD6B55",
                                        confirmButtonText: $translate.instant('Confirm'),
                                        cancelButtonText: $translate.instant('Cancel'),
                                        closeOnConfirm: true
                                    }, function (isConfirm) {
                                        if (isConfirm) {
                                            var id = info.data.id;
                                            $scope.detail.items = _.map($scope.detail.items, function (item) {
                                                if (item.type == $scope.detail.cellType && item.id == $scope.selectedTabId) {
                                                    item.dataSource = _.filter(item.dataSource, function (itemData) {
                                                        return itemData.id != id;
                                                    });
                                                    //重新计算datasource的值
                                                    calculateFilterDatasourceAmount(item);
                                                    //更新数据库
                                                    vatReportService.updateDataSourceAmount(item.id, item.amount);
                                                    vatReportService.deleteCellVoucher(id, item.id);
                                                }
                                                return item;
                                            });

                                            $scope.detail.dataGridSource = _.filter($scope.detail.dataGridSource, function (item) {
                                                return item.id != id;
                                            });
                                        }
                                    });
                                });
                            }
                        }
                    ];
                    break;
                case enums.formulaDataSourceType.Report:
                    //报表数据源
                    dataGridColumns = [
                        {
                            dataField: 'period',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '10%',
                            visible: vatSessionService.citFlag ? false : true
                        },
                        {
                            dataField: 'reportName',
                            caption: $translate.instant('ReportName'),
                            alignment: 'left',
                            width: '16%'
                        },
                        // {dataField: 'project', caption: $translate.instant('Project'), alignment: 'left', width: '25%'},
                        // {
                        //     dataField: 'reportColumn',
                        //     caption: $translate.instant('TaxReportColumn'),
                        //     alignment: 'left',
                        //     width: '17%'
                        // },
                        {
                            dataField: 'cellName',
                            caption: $translate.instant('CellColumn'),
                            alignment: 'left',
                            width: '16%'
                        },
                        {
                            dataField: 'cellValue',
                            caption: $translate.instant('CellValue'),
                            alignment: 'right',
                            width: '16%',
                            format: {type: 'fixedPoint', precision: $scope.detail.dataType === 5 ? 0 : 2}
                        }
                    ];
                    break;
                case enums.formulaDataSourceType.BSPL:
                    //BSPL数据源
                    dataGridColumns = [
                        {
                            dataField: 'index',
                            caption: $translate.instant('SequenceNo'),
                            alignment: 'center',
                            width: '10%'
                        },
                        {dataField: 'account', caption: $translate.instant('Account'), alignment: 'left', width: '60%'},
                        {
                            dataField: 'amount',
                            caption: $translate.instant('Amount'),
                            alignment: 'right',
                            width: '30%',
                            format: {type: 'fixedPoint', precision: 2}
                        }
                    ];
                    break;
                case enums.formulaDataSourceType.Judgment:
                    //条件判断数据源
                    dataGridColumns = [
                        {
                            dataField: 'cellIndex',
                            caption: $translate.instant('SequenceNo'),
                            alignment: 'center',
                            width: '10%'
                        },
                        {
                            dataField: 'period',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '10%'
                        },
                        {
                            dataField: 'reportName',
                            caption: $translate.instant('ReportName'),
                            alignment: 'left',
                            width: '16%'
                        },
                        {dataField: 'project', caption: $translate.instant('Project'), alignment: 'left', width: '16%'},
                        {
                            dataField: 'column',
                            caption: $translate.instant('TaxReportColumn'),
                            alignment: 'left',
                            width: '16%'
                        },
                        {
                            dataField: 'cellConditionName',
                            caption: $translate.instant('CellColumn'),
                            alignment: 'left',
                            width: '16%'
                        },
                        {
                            dataField: 'cellConditionValue',
                            caption: $translate.instant('CellValue'),
                            alignment: 'right',
                            width: '16%',
                            format: {type: 'fixedPoint', precision: 2}
                        }
                    ];
                    break;
                case enums.formulaDataSourceType.InvoiceFilter:
                    //发票筛选
                    dataGridColumns = [
                        {
                            dataField: 'period',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '10%'
                        },
                        {
                            dataField: 'inputInvoiceDate',
                            caption: $translate.instant('InvoiceRZRQ'),
                            alignment: 'left',
                            visible: $scope.detail.invoiceType === 1,
                            width: '20%'
                        },
                        {
                            dataField: 'outputInvoiceDate',
                            caption: $translate.instant('InvoiceKPRQ'),
                            alignment: 'left',
                            visible: $scope.detail.invoiceType === 2,
                            width: '20%'
                        },
                        {
                            dataField: 'IssueDate',
                            caption: $translate.instant('CustomsIssueDate'),
                            alignment: 'left',
                            visible: $scope.detail.invoiceType === 3,
                            width: '20%'
                        },
                        {
                            dataField: 'invoiceCode',
                            caption: $translate.instant('InvoiceFPDM'),
                            alignment: 'left',
                            visible: $scope.detail.invoiceType != 3,
                            width: '20%'
                        },
                        {
                            dataField: 'invoiceNumber',
                            caption: $translate.instant('InvoiceFPHM'),
                            alignment: 'left',
                            visible: $scope.detail.invoiceType != 3,
                            width: '20%'
                        },
                        {
                            dataField: 'payNum',
                            caption: $translate.instant('CustomsPayNum'),
                            alignment: 'left',
                            visible: $scope.detail.invoiceType === 3,
                            width: '20%'
                        },
                        {
                            dataField: 'amount',
                            caption: $translate.instant('InvoiceJE'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2, width: '20%'}
                        },
                        {
                            dataField: 'taxRate',
                            caption: $translate.instant('InvoiceSL'),
                            alignment: 'left',
                            width: '20%'
                        },
                        {
                            dataField: 'taxAmount',
                            caption: $translate.instant('InvoiceSE'),
                            alignment: 'right',
                            width: '20%',
                            format: {type: 'fixedPoint', precision: 2},
                            visible: $scope.detail.invoiceType != 3
                        },
                        {
                            dataField: 'productionName',
                            caption: $translate.instant('InvoiceHWMC'),
                            alignment: 'left',
                            width: '20%',
                            visible: $scope.detail.invoiceType === 1
                        },
                        {
                            dataField: 'buyerName',
                            caption: $translate.instant('BuyerName'),
                            alignment: 'left',
                            width: '20%',
                            visible: $scope.detail.invoiceType === 2
                        },
                        {
                            dataField: 'invoiceType',
                            caption: $translate.instant('InvoiceType'),
                            alignment: 'left',
                            width: '20%',
                            visible: $scope.detail.invoiceType === 2
                        },
                        {
                            dataField: 'auditResult',
                            caption: $translate.instant('CustomsAuditResult'),
                            alignment: 'left',
                            width: '20%',
                            visible: $scope.detail.invoiceType === 3
                        },
                        {
                            dataField: 'operate',
                            caption: $translate.instant('Operate'),
                            alignment: 'center',
                            width: '20%',
                            cellTemplate: function (element, info) {
                                $('<span>').css('cursor', 'pointer').html('<i class="fa fa-trash delete-icon" style="color: red;" role="button" tabindex="0" />').appendTo(element);
                                $(element).click(function () {
                                    SweetAlert.swal({
                                        title: $translate.instant('ConfirmDelete'),
                                        text: '',
                                        type: "warning",
                                        showCancelButton: true,
                                        confirmButtonColor: "#DD6B55",
                                        confirmButtonText: $translate.instant('Confirm'),
                                        cancelButtonText: $translate.instant('Cancel'),
                                        closeOnConfirm: true
                                    }, function (isConfirm) {
                                        if (isConfirm) {
                                            var id = info.data.id;

                                            $scope.detail.items = _.map($scope.detail.items, function (item) {
                                                if (item.type == $scope.detail.cellType && item.id == $scope.selectedTabId) {
                                                    item.dataSource = _.filter(item.dataSource, function (itemData) {
                                                        return itemData.id != id;
                                                    });
                                                    calculateFilterDatasourceAmount(item);
                                                    vatReportService.updateDataSourceAmount(item.id, item.amount);
                                                    vatReportService.deleteCellInvoice(id, item.id);
                                                }
                                                return item;
                                            });
                                            $scope.detail.dataGridSource = _.filter($scope.detail.dataGridSource, function (item) {
                                                return item.id != id;
                                            });
                                        }
                                    });
                                });
                            }
                        }
                    ];
                    break;
                case enums.formulaDataSourceType.ModelDatasource:
                    dataGridColumns = [
                        {
                            dataField: 'index',
                            caption: $translate.instant('ModelPeriod'),
                            alignment: 'center',
                            width: '20%'
                        },
                        {
                            dataField: 'reportColumn',
                            caption: $translate.instant('ModelName'),
                            alignment: 'left',
                            width: '40%'
                        },
                        {
                            dataField: 'cellValue',
                            caption: $translate.instant('FillBack'),
                            alignment: 'left',
                            width: '40%',
                            format: {type: 'fixedPoint', precision: $scope.detail.dataType === 5 ? 0 : 2}
                        },
                    ];
                    break;
                case enums.formulaDataSourceType.Special:
                    dataGridColumns = [
                        {dataField: 'money', caption: 'Amount', alignment: 'center', width: '100%'},
                    ];
                    break;
            }
            return dataGridColumns;
        };



        //设置数据源表格的列
        var getAllDataGridColumns = function () {
            var dataGridColumns;
            switch ($scope.detail.allCellType) {
                case enums.cellDataSourceType.InputInvoice:
                    //进项明细数据源
                    dataGridColumns = [
                        {
                            dataField: 'period',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '80px'
                        },
                        {
                            dataField: 'invoiceDate',
                            caption: $translate.instant('InvoiceKPRQ'),
                            alignment: 'left',
                            dataType: "date",
                            customizeText: function (cellInfo) {
                                if (cellInfo && cellInfo.value) {
                                    return new Date(cellInfo.value).dateTimeToString('yyyyMMdd');
                                }
                                return "";
                            }
                        },
                        {dataField: 'invoiceCode', caption: $translate.instant('InvoiceFPDM'), alignment: 'left'},
                        {dataField: 'invoiceNumber', caption: $translate.instant('InvoiceFPHM'), alignment: 'left'},
                        {
                            dataField: 'taxAmount',
                            caption: $translate.instant('InvoiceJE'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2}
                        },
                        {dataField: 'rate', caption: $translate.instant('InvoiceSL'), alignment: 'left'},
                        {
                            dataField: 'taxAmount',
                            caption: $translate.instant('InvoiceSE'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2}
                        },
                        {dataField: 'productionName', caption: $translate.instant('InvoiceHWMC'), alignment: 'left'}
                    ];
                    break;
                case enums.cellDataSourceType.OutputInvoice:
                    //销项发票数据源
                    dataGridColumns = [
                        {
                            dataField: 'period',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '80px'
                        },
                        {dataField: 'invoiceCode', caption: $translate.instant('InvoiceFPDM'), alignment: 'left'},
                        {dataField: 'invoiceNumber', caption: $translate.instant('InvoiceFPHM'), alignment: 'left'},

                        {dataField: 'buyerName', caption: $translate.instant('BuyerName'), alignment: 'left'},
                        {
                            dataField: 'invoiceDate',
                            caption: $translate.instant('InvoiceKPRQ'),
                            alignment: 'left',
                            customizeText: function (cellInfo) {
                                if (cellInfo && cellInfo.value) {
                                    return new Date(cellInfo.value).dateTimeToString('yyyyMMdd');
                                }
                                return "";
                            }
                        },
                        {dataField: 'taxRate', caption: $translate.instant('InvoiceSL'), alignment: 'left'},
                        {
                            dataField: 'amount',
                            caption: $translate.instant('InvoiceJE'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2}
                        },

                        {
                            dataField: 'taxAmount',
                            caption: $translate.instant('InvoiceSE'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2}
                        },
                        {dataField: 'invoiceType', caption: $translate.instant('InvoiceType'), alignment: 'left'}
                    ];
                    break;
                case enums.cellDataSourceType.CustomInvoice:
                    //海关稽核
                    dataGridColumns = [
                        {
                            dataField: 'periodId',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '80px'
                        },
                        {
                            dataField: 'issueDate',
                            caption: $translate.instant('CustomsIssueDate'),
                            alignment: 'left',
                            customizeText: function (cellInfo) {
                                if (cellInfo && cellInfo.value) {
                                    return new Date(cellInfo.value).dateTimeToString('yyyyMMdd');
                                }
                                return "";
                            }
                        },
                        {dataField: 'payNum', caption: $translate.instant('CustomsPayNum'), alignment: 'left'},
                        {
                            dataField: 'invoiceTaxAmount',
                            caption: $translate.instant('InvoiceSE'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2}
                        },
                        {
                            dataField: 'invoiceAmount',
                            caption: $translate.instant('Amount'),
                            alignment: 'left',
                            format: {type: 'fixedPoint', precision: 2}
                        },
                        {dataField: 'auditResult', caption: $translate.instant('CustomsAuditResult'), alignment: 'left'}
                    ];
                    break;
                case enums.cellDataSourceType.Voucher:
                    //凭证选择
                    dataGridColumns = [
                        {
                            dataField: 'period',
                            caption: $translate.instant('InvoiceQJ'),
                            alignment: 'center',
                            width: '80px'
                        },
                        {dataField: 'date', caption: $translate.instant('VoucherDate'), alignment: 'left'},
                        {
                            dataField: 'accountSubject',
                            caption: $translate.instant('EntempriseAccount'),
                            alignment: 'left'
                        },
                        {dataField: 'voucherCode', caption: $translate.instant('VoucherCode'), alignment: 'left'},
                        {dataField: 'voucherSummary', caption: $translate.instant('VoucherSummary'), alignment: 'left'},
                        {
                            dataField: 'debitAmount',
                            caption: $translate.instant('DebitAmount'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2}
                        },
                        {
                            dataField: 'creditAmount',
                            caption: $translate.instant('CreditAmount'),
                            alignment: 'right',
                            format: {type: 'fixedPoint', precision: 2}
                        }
                    ];
                    break;
            }
            return dataGridColumns;
        };

        //添加数据源（发票|凭证）数据过滤
        var allDataFilter = function (config, data) {
            var dataGridColumns;
            switch ($scope.detail.allCellType) {
                case enums.cellDataSourceType.Voucher:
                    data = _.map(data, function (item) {
                        item.date = item.date ? (new Date(item.date)).dateTimeToString('yyyyMMdd') : ""
                        return item;
                    });
                    return data.filter(function (x) {
                        if ($scope.voucherRange.voucherKeyword) {

                            return x.voucherSummary && x.voucherSummary.indexOf($scope.voucherRange.voucherKeyword) > -1;
                        } else {
                            return _.contains(config.accountCodes, x.accountSubject)
                        }
                    });
                case enums.cellDataSourceType.InputInvoice:
                    return data.filter(function (x) {
                        return (config.taxRate == "99" ||
                            _.contains(config.taxRate.map(function (r) {
                                return percentToPoint(r)
                            }), x.rate)) &&
                            _.contains(config.invoiceCategory, x.invoiceType);
                    });
                case enums.cellDataSourceType.OutputInvoice:
                    data = data.filter(function (x) {
                        return (_.contains(config.taxRate.map(function (r) {
                                return percentToPoint(r)
                            }), x.taxRate) || config.taxRate == "99") &&
                            _.contains(config.invoiceCategory, x.invoiceType);
                    });
                    data = _.map(data, function (item) {
                        item.invoiceType = getOutputInvoiceTypeName(item.invoiceType);
                        return item;
                    });
                    return data;
                case enums.cellDataSourceType.CustomInvoice:
                    return data;
            }
        };

        //添加数据源
        var addDataSource = function () {
            var parentElem = angular.element($document[0].querySelector('#addSourceContainer'));
            var modalInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                templateUrl: 'addDataSourceModal.html',
                controller: addDataSourceController,
                windowClass: 'data-table',
                appendTo: parentElem,
                scope: $scope
            });
        };

        //添加发票|凭证
        var addInvoiceAndVoucher = function (type) {
            $scope.addDataSourceType = type;
            $scope.selectedInvoice = [];
            $scope.addInvoiceClick = true;
            _.each($scope.detail.dataGridSource, function (item) {
                $scope.selectedInvoice.push(item.id)
            });
            addDataSource();
        }

        //计算凭证的数值
        function calculateVoucherValue(voucher) {
            return voucher.direction * ((voucher.debitAmount ? voucher.debitAmount : 0) - (voucher.creditAmount ? voucher.creditAmount : 0));
        }

        var addDataSourceController = function ($scope) {
            var config = $scope.$parent.detail.config;
            //default value
            if (config.hasVoucher && !config.hasInvoice) {
                config.voucherClass = activeClass;
            } else if (!config.hasVoucher && config.hasInvoice) {
                config.invoiceClass = activeClass;
            }

            config.addClass = activeClass;
            config.contentStatus = 'dataSourceTitle';
            config.dataSourceName = '';

            //如果是以添加发票|添加凭证的形式打开弹框
            if ($scope.$parent.addInvoiceClick) {
                config.contentStatus = 'dataSourceDetail';

                var dataSourceType = 0;
                var sDataSourceType = 0;
                if (config.hasVoucher) {
                    dataSourceType = enums.cellDataSourceType.Voucher;
                    sDataSourceType = enums.formulaDataSourceType.Voucher;
                } else if (config.hasInvoice) {
                    if (config.invoiceType === 1) {
                        dataSourceType = enums.cellDataSourceType.InputInvoice;
                        sDataSourceType = enums.formulaDataSourceType.InputInvoice;

                    } else if (config.invoiceType === 2) {
                        dataSourceType = enums.cellDataSourceType.OutputInvoice;
                        sDataSourceType = enums.formulaDataSourceType.OutputInvoice;

                    } else if (config.invoiceType === 3) {
                        dataSourceType = enums.cellDataSourceType.CustomInvoice;
                        sDataSourceType = enums.formulaDataSourceType.Other;
                    }
                }
                config.dataSourceType = dataSourceType;

                config.dataSourceID = $scope.$parent.selectedTabId;
                config.dataSourceName = $scope.$parent.selectedTypeName;
                showAllItems(config);
                //以添加凭证或添加发票打开,则运算方法取当前选中tab的运算方法。
                config.OperationType = $scope.$parent.currentOperationType;
                $scope.$parent.addInvoiceClick = false;
            }

            $scope.config = config;
            $scope.choiceGroupButton = choiceGroupButton;

            $scope.confirmAddDataSource = function (config) {
                if (config.contentStatus === 'dataSourceTitle') {
                    saveDataSource(config);
                    config.contentStatus === 'dataSourceDetail'
                } else {
                    //添加数据源
                    var invoiceList = $scope.$parent.selectedAddDatasourceItems;
                    var tabValue = 0;
                    if (invoiceList && invoiceList.length > 0) {
                        $(invoiceList).each(function (index, item) {
                            if (config.hasVoucher) {
                                item.type = enums.formulaDataSourceType.VoucherFilter;
                            } else {
                                item.type = enums.formulaDataSourceType.InvoiceFilter;
                            }
                        });
                        $scope.$parent.detail.items = _.map($scope.$parent.detail.items, function (item) {
                            if (item.id === config.dataSourceID && item.name === config.dataSourceName) {
                                item.dataSource = [];
                            }
                            return item;
                        });

                        _.each(invoiceList, function (invoice) {
                            var model = {};
                            if (config.hasVoucher) {
                                tabValue += calculateVoucherValue(invoice);
                                model = translateInvoiceFilterDataSource(invoice, invoice.type, config.OperationType);
                            } else {
                                if (config.invoiceAmountType == enums.invoiceAmountType.amount) {
                                    tabValue += invoice.amount;
                                } else if (config.invoiceAmountType == enums.invoiceAmountType.taxAmount) {
                                    tabValue += invoice.taxAmount;
                                } else if (config.invoiceAmountType == enums.invoiceAmountType.quntity) {
                                    tabValue += 1;
                                }
                                model = translateInvoiceFilterDataSource(invoice, config.invoiceType, config.OperationType);
                            }

                            var filterItems = _.where($scope.$parent.detail.items, {
                                id: config.dataSourceID,
                                name: config.dataSourceName
                            });

                            if (filterItems && filterItems.length > 0) {
                                $scope.$parent.detail.items = _.map($scope.$parent.detail.items, function (item) {
                                    if (item.id === config.dataSourceID && item.name === config.dataSourceName && item.type === invoice.type) {
                                        item.dataSource.push(model);
                                    }
                                    return item;
                                });
                            } else {
                                $scope.$parent.detail.cellType = invoice.type;
                                $scope.$parent.detail.cellTypeId = config.dataSourceID;
                                $scope.$parent.selectedDataSourceTabIndex = 1;
                                $scope.$parent.detail.dataSourceCount++;
                                $scope.$parent.detail.items.push({
                                    type: invoice.type,
                                    name: config.dataSourceName,
                                    id: config.dataSourceID,
                                    operationType: config.OperationType,
                                    amount: 0,
                                    dataSource: [model]
                                });
                            }
                        });
                    }

                    var dataSource = {
                        id: config.dataSourceID,
                        items: $scope.selectedItems,
                        projectID: vatSessionService.project.id,
                        amount: tabValue,
                        serviceTypeID: vatSessionService.project.serviceTypeID,
                        DataSourceType: config.dataSourceType
                    };
                    vatReportService.addDataSourceItems(dataSource).success(function () {
                        SweetAlert.warning($translate.instant('AddSuccess'));
                        $scope.$dismiss({$value: 'cancel'});
                    });
                    $rootScope.$broadcast('loadData', {});
                    $rootScope.$broadcast('cellValueReset',
                        {
                            row: $scope.detail.rowIndex,
                            col: $scope.detail.columnIndex,
                        });

                }
            };

            $scope.hideAddDataSourcePanel = function () {
                $scope.$dismiss({$value: 'cancel'});
            };
        };

        addDataSourceController.$inject = ['$scope'];

        var saveDataSource = function (config) {
            var dataSourceType = 0;
            var sDataSourceType = 0;
            if (config.hasVoucher) {
                dataSourceType = enums.formulaDataSourceType.Voucher;
                sDataSourceType = enums.cellDataSourceType.Voucher;
            } else if (config.hasInvoice) {
                if (config.invoiceType === 1) {
                    dataSourceType = enums.formulaDataSourceType.InputInvoice;
                    sDataSourceType = enums.cellDataSourceType.InputInvoice;

                } else if (config.invoiceType === 2) {
                    dataSourceType = enums.formulaDataSourceType.OutputInvoice;
                    sDataSourceType = enums.cellDataSourceType.OutputInvoice;

                } else if (config.invoiceType === 3) {
                    dataSourceType = enums.formulaDataSourceType.CustomInvoice;
                    sDataSourceType = enums.cellDataSourceType.CustomInvoice;
                }
            }

            config.dataSourceType = sDataSourceType;
            var newDataSource = {
                name: config.dataSourceName,
                dataSourceType: dataSourceType,
                cellDataID: config.cellID,
                creator: loginContext.userId,
                updater: loginContext.userId,
                operationType: config.addClass === activeClass ? 1 : 2,
                cellTemplateID: config.cellTemplateID,
                rowIndex: config.rowIndex,
                columnIndex: config.columnIndex,
                period: vatSessionService.month
            };
            config.OperationType = config.addClass === activeClass ? 1 : 2;
            vatReportService.addDataSource(newDataSource).success(function (result) {
                if (result && result.result) {
                    config.dataSourceID = result.data;
                    showAllItems(config);
                }
            });
        };

        //根据销项发票类型获取销项发票类型名称
        var getOutputInvoiceTypeName = function (invoiceType) {
            for (var item in enums.outputInvoiceType) {
                if (enums.outputInvoiceType[item] == invoiceType) {
                    return $translate.instant(item);
                }
            }
            return invoiceType;
        }

        //解析发票筛选|凭证筛选数据
        var translateInvoiceFilterDataSource = function (sourceData, type, operationType) {
            var obj = new Object();
            switch (type) {
                case 1:
                    obj.id = sourceData.id;
                    obj.period = sourceData.period;
                    obj.inputInvoiceDate = sourceData.invoiceDate ? (new Date(sourceData.invoiceDate)).dateTimeToString('yyyyMMdd') : "";
                    obj.invoiceCode = sourceData.invoiceCode;
                    obj.invoiceNumber = sourceData.invoiceNumber;
                    obj.amount = sourceData.amount;
                    obj.taxRate = sourceData.rate * 100 + '%';
                    obj.taxAmount = sourceData.taxAmount;
                    obj.productionName = sourceData.productionName;
                    obj.operationType = operationType;
                    break;
                case 2:
                    obj.id = sourceData.id;
                    obj.period = sourceData.period;
                    obj.outputInvoiceDate = sourceData.invoiceDate ? sourceData.invoiceDate.substring(0, 10) : '';
                    obj.buyerName = sourceData.buyerName;
                    obj.invoiceCode = sourceData.invoiceCode;
                    obj.invoiceNumber = sourceData.invoiceNumber;
                    obj.amount = sourceData.amount;
                    obj.taxRate = sourceData.taxRate * 100 + '%';
                    obj.taxAmount = sourceData.taxAmount;
                    obj.invoiceType = getOutputInvoiceTypeName(sourceData.invoiceType);
                    obj.operationType = operationType;
                    break;
                case 3:
                    obj.id = sourceData.customsId;
                    obj.period = sourceData.periodId;
                    obj.IssueDate = sourceData.IssueDate;
                    obj.amount = sourceData.InvoiceAmount;
                    obj.taxRate = sourceData.InvoiceTaxAmount;
                    obj.payNum = sourceData.payNum;
                    obj.auditResult = sourceData.auditResult;
                    obj.operationType = operationType;
                    break;
                //凭证筛选
                case enums.formulaDataSourceType.VoucherFilter:
                    obj.id = sourceData.id;
                    obj.period = sourceData.period;
                    obj.date = sourceData.date ? (new Date(sourceData.date)).dateTimeToString('yyyyMMdd') : "";
                    obj.enterpriseAccounting = sourceData.accountSubject;
                    obj.voucherNumber = sourceData.voucherCode;
                    obj.voucherSammary = sourceData.voucherSummary;
                    obj.debitAmount = sourceData.debitAmount;
                    obj.creditAmount = sourceData.creditAmount;
                    obj.operationType = operationType;
                    obj.direction = sourceData.direction;
                    break;
            }
            return obj;
        }

        var allItemsDataSourceOptions = {
            bindingOptions: {
                columns: 'allItemDataGridColumns',
                dataSource: 'detail.allItemsDataGridSource',
                height: 'allItemDataGridHeight',
                selectedRowKeys: 'selectedInvoice'
            },
            loadPanel: {
                enabled: false
            },
            scrolling: {
                mode: "standard"
            },
            searchPanel: {
                visible: false
            },
            selection: {
                mode: "multiple",
                allowSelectAll: false
            },
            sorting: {
                mode: 'single'
            },
            filterRow: {
                visible: true
            },
            onSelectionChanged: function (selectedItems) {
                $scope.selectedItems = $.map(selectedItems.selectedRowsData, function (data) {
                    $scope.selectedAddDatasourceItems = selectedItems.selectedRowsData;
                    return data.id;
                });

                $log.debug($scope.selectedItems);
            },
            allowColumnResizing: true,
            hoverStateEnabled: true,
            showBorders: true,
            showRowLines: true,
            showColumnLines: true,
        };

        var showAllItems = function (config) {
            config.contentStatus = 'allItems';
            var project = vatSessionService.project;
            vatReportService.getAllDataItems(config.dataSourceType).success(function (res) {
                var result = JSON.parse(res.data);
                if (result && result.length > 0) {
                    $scope.detail.allCellType = config.dataSourceType;
                    $scope.detail.allItemsDataGridSource = {
                        store: {
                            data: allDataFilter(config, result),
                            type: 'array',
                            key: 'id'
                        }
                    };
                }
            });
        };

        var choiceGroupButton = function (config, selectCode, unSelectCode) {
            config[selectCode] = activeClass;
            config[unSelectCode] = '';
        };

        var percentToPoint = function (percent) {
            var str = percent.replace("%", "");
            str = str / 100;
            return str;
        };

        var getFormulaList = function () {
            $q.all([
                formulaService.getAll(),
                formulaService.getAllParam(),
                formulaService.getAllParamMapping()
            ]).then(function (result) {
                if (!_.isEmpty(result[0]) && !_.isEmpty(result[0].data) && !_.isEmpty(result[0].data.data)) {
                    var formulaList = _.map(result[0].data.data, function (config) {
                        return {
                            id: config.id,
                            code: config.formulaName,
                            name: config.chineseName,
                            description: config.description,
                            englishName: config.englishName,
                            requiredParamNum: config.requiredParamNum
                        }
                    });

                    if (!_.isEmpty(result[1]) && !_.isEmpty(result[1].data) && !_.isEmpty(result[1].data.data) &&
                        !_.isEmpty(result[2]) && !_.isEmpty(result[2].data) && !_.isEmpty(result[2].data.data)) {
                        var groupedParamList = _.groupBy(result[2].data.data, 'formulaID');
                        var paramList = result[1].data.data;
                        _.each(groupedParamList, function (val, key) {
                            var formula = _.findWhere(formulaList, {id: key});
                            if (formula) {
                                formula.params = _.chain(val)
                                    .map(function (p) {
                                        return {id: p.formulaParamID, index: p.paramIndex};
                                    })
                                    .sortBy(function (p) {
                                        return p.index;
                                    }).value();
                                _.each(formula.params, function (p, idx) {
                                    var param = _.findWhere(paramList, {id: p.id});
                                    _.extend(p, param);
                                });
                            }
                        });
                    }

                    $scope.formulaList = formulaList;
                }
            });
        };

        //计算每个datasource的值
        function calculateFilterDatasourceAmount(filterDatasource, isDirectionCal) {
            isDirectionCal = isDirectionCal || false;
            var datasourceAmountValue = 0;
            if (filterDatasource.type == enums.formulaDataSourceType.VoucherFilter) {
                _.each(filterDatasource.dataSource, function (voucher) {
                    if (!isDirectionCal || filterDatasource.operationType == 1) { //加法
                        datasourceAmountValue += calculateVoucherValue(voucher);
                    } else if (filterDatasource.operationType == 2) { //减法
                        datasourceAmountValue -= calculateVoucherValue(voucher);
                    }
                });
                filterDatasource.amount = datasourceAmountValue;

            } else if (filterDatasource.type == enums.formulaDataSourceType.InvoiceFilter) {
                _.each(filterDatasource.dataSource, function (invoice) {
                    if (!isDirectionCal || filterDatasource.operationType == 1) { //加法
                        if ($scope.detail.config.invoiceAmountType == enums.invoiceAmountType.amount) {
                            datasourceAmountValue += invoice.amount;
                        } else if ($scope.detail.config.invoiceAmountType == enums.invoiceAmountType.taxAmount) {
                            datasourceAmountValue += invoice.taxAmount;
                        } else if ($scope.detail.config.invoiceAmountType == enums.invoiceAmountType.quntity) {
                            datasourceAmountValue += 1;
                        }
                    } else if (filterDatasource.operationType == 2) { //减法
                        if ($scope.detail.config.invoiceAmountType == enums.invoiceAmountType.amount) {
                            datasourceAmountValue -= invoice.amount;
                        } else if ($scope.detail.config.invoiceAmountType == enums.invoiceAmountType.taxAmount) {
                            datasourceAmountValue -= invoice.taxAmount;
                        } else if ($scope.detail.config.invoiceAmountType == enums.invoiceAmountType.quntity) {
                            datasourceAmountValue -= 1;
                        }
                    }
                });
                filterDatasource.amount = datasourceAmountValue;
            }

            return datasourceAmountValue;
        }

        $scope.$watch('detail.dataGridSource', function (newVal, oldValue) {
            $timeout(function () {
                $scope.selectedTabIndex = $scope.detail.cellType;
                $scope.selectedTabId = $scope.detail.cellTypeId;

                $($scope.detail.items).each(function (index, element) {
                    if (element.type === $scope.detail.cellType && element.id === $scope.selectedTabId &&
                        (element.type !== enums.formulaDataSourceType.OutputInvoice &&
                            element.type !== enums.formulaDataSourceType.Voucher &&
                            element.type !== enums.formulaDataSourceType.Special ||
                            _.isEmpty($scope.selectedTypeName) || $scope.selectedTypeName === element.name)) {
                        $scope.detail.dataGridSource = element.dataSource;
                        $scope.selectedTypeName = element.name;
                        switch ($scope.detail.cellType) {
                            case enums.formulaDataSourceType.OutputInvoice:
                                $scope.detail.dataGridSourceBind = [$scope.detail.dataGridSource[0]];
                                break;
                            case enums.formulaDataSourceType.WPSR:
                                $scope.detail.dataGridSourceBind = [$scope.detail.dataGridSource[0]];
                                break;
                            case enums.formulaDataSourceType.TrialBalanceSource:
                                $scope.detail.dataGridSourceBind = [$scope.detail.dataGridSource[0]];
                                break;
                            case enums.formulaDataSourceType.InputInvoice:
                                $scope.detail.dataGridSourceBind = [$scope.detail.dataGridSource[0]];
                                break;
                            case enums.formulaDataSourceType.InputInvoice:
                                $scope.detail.dataGridSourceBind = [$scope.detail.dataGridSource[0]];
                                break;
                            default :
                                $scope.detail.dataGridSourceBind = $scope.detail.dataGridSource;
                                break;
                        }
                        //if (element.name === 'MaxConditionDataSource') {
                        //    $scope.dataSourceOptions.summary.totalItems[4].summaryType = 'max';
                        //} else {
                        //    $scope.dataSourceOptions.summary.totalItems[4].summaryType = 'min';
                        //}
                        return;
                    }
                });


                $scope.dataGridColumns = getDataGridColumns();
                getConclusionVal();

            }, 500);
        });
        //当数据源数量变化是，重新排序数据源
        $scope.$watch('detail.items.length', function (newVal, oldValue) {

            if (newVal) {
                $scope.detail.items = _.sortBy($scope.detail.items, function (item) {
                    if (item.type === enums.formulaDataSourceType.ModelDatasource ||
                        item.type === enums.formulaDataSourceType.InvoiceFilter ||
                        item.type === enums.formulaDataSourceType.VoucherFilter) {
                        return new Date(item.createTime).dateTimeToString('yyyyMMddHHmmss');
                    } else {
                        return new Date().dateTimeToString('yyyyMMddHHmmss');
                    }
                });

                var firstItem = _.first($scope.detail.items);
                $scope.detail.cellType = firstItem.type;
                $scope.detail.cellTypeId = firstItem.id;
                $scope.selectedTabIndex = $scope.detail.cellType;
                $scope.selectedTabId = $scope.detail.cellTypeId;
                $scope.selectedTypeName = firstItem.name;
            }
        });

        $scope.$watch('detail.items', function (newVal, oldValue) {
            $timeout(function () {

                $scope.selectedTabIndex = $scope.detail.cellType;
                $scope.selectedTabId = $scope.detail.cellTypeId;
                $scope.selectedTypeName = null;

                var cellAmountValue = 0;
                $($scope.detail.items).each(function (index, element) {

                    if (!$scope.selectedTabId) {
                        $scope.selectedTabIndex = element.type;
                        $scope.selectedTabId = element.id;
                    }

                    if (element.type === $scope.detail.cellType && element.id === $scope.selectedTabId &&
                        (element.type !== enums.formulaDataSourceType.OutputInvoice &&
                            element.type !== enums.formulaDataSourceType.Voucher &&
                            element.type !== enums.formulaDataSourceType.Special ||
                            _.isEmpty($scope.selectedTypeName) || $scope.selectedTypeName === element.name)) {
                        $scope.detail.dataGridSource = element.dataSource;
                        $scope.selectedTypeName = element.name;
                        $scope.currentOperationType = element.operationType
                        //if (element.name === 'MaxConditionDataSource') {
                        //    $scope.dataSourceOptions.summary.totalItems[4].summaryType = 'max';
                        //} else {
                        //    $scope.dataSourceOptions.summary.totalItems[4].summaryType = 'min';
                        //}
                        switch ($scope.detail.cellType) {
                            case enums.formulaDataSourceType.OutputInvoice:
                                $scope.detail.dataGridSourceBind = [$scope.detail.dataGridSource[0]];
                                break;
                            case enums.formulaDataSourceType.TrialBalanceSource:
                                $scope.detail.dataGridSourceBind = [$scope.detail.dataGridSource[0]];
                                break;
                            case enums.formulaDataSourceType.InputInvoice:
                                $scope.detail.dataGridSourceBind = [$scope.detail.dataGridSource[0]];
                                break;
                            default :
                                $scope.detail.dataGridSourceBind = $scope.detail.dataGridSource;
                                break;
                        }
                    }
                    cellAmountValue += calculateFilterDatasourceAmount(element, true);
                });

                if ($scope.detail && $scope.detail.cellInfo && ($scope.detail.config.hasInvoice || $scope.detail.config.hasVoucher)) {
                    //数值 = 单元格的除凭证和发票外的数值 + 凭证和发票的数值
                    $scope.detail.cellInfo.money = $scope.detail.cellSubValue + cellAmountValue;
                    if ($scope.detail.config.invoiceAmountType == enums.invoiceAmountType.quntity) {
                        $scope.detail.cellInfo.money = $scope.detail.cellInfo.money.formatAmount(0);
                    } else {
                        $scope.detail.cellInfo.money = $scope.detail.cellInfo.money.formatAmount(2);
                    }
                }
                $scope.dataGridColumns = getDataGridColumns();
                getConclusionVal();

                $scope.isWriteBackUpdate = true;

            }, 500);
        });

        $scope.$watchGroup(['detail.rowIndex', 'detail.columnIndex'], function () {
            //获取凭证筛选范围
            if ($scope.detail.reportTemplateId) {
                vatReportService.getCellAccountRange($scope.detail.reportTemplateId, vatSessionService.month, $scope.detail.rowIndex, $scope.detail.columnIndex).success(function (result) {
                    if (result && result.data && result.data.length > 0) {
                        $scope.selectedAccount = result.data;
                        $scope.selectedAccountTemp = result.data;
                        $scope.selectedAccountCodes = _.pluck($scope.selectedAccount, 'code');
                    } else {
                        $scope.selectedAccount = [];
                        $scope.selectedAccountTemp = [];
                        $scope.selectedAccountCodes = [];
                    }
                });
                vatReportService.getCellTemplateConfig($scope.detail.reportTemplateId, vatSessionService.month, $scope.detail.rowIndex, $scope.detail.columnIndex).success(function (result) {
                    if (result && result.data) {
                        if (result.data.voucherKeyword) {
                            $scope.voucherRange.filterWay = '2';
                            $scope.voucherRange.voucherKeyword = result.data.voucherKeyword;
                        } else {
                            $scope.voucherRange.filterWay = '1';
                        }
                    } else {
                        $scope.voucherRange.filterWay = '1';
                    }
                });
            }

            //获取标准科目用于设置凭证筛选范围。
            vatReportService.getStdAccountByIndustryID(vatSessionService.project.industryID)
                .success(function (data) {
                    if (data && data.length > 0) {
                        _.each(data, function (account) {
                            account.directionName = $translate.instant(enums.standardAccountDirection[account.direction]);
                            account.acctPropName = $translate.instant(enums.standardAccountAcctProp[account.acctProp]);
                            account.AcctPropName = $translate.instant(enums.standardAccountAcctProp[account.acctProp]);
                            account.code = account.acctCode;
                        });
                    }

                    if (data && data.length > 0) {
                        $scope.accountDataSource = data;
                    }
                });
        });

        $scope.$watch('detail.allItemsDataGridSource', function (newVal, oldValue) {
            if (newVal !== oldValue) {
                $scope.allItemDataGridColumns = getAllDataGridColumns();
                $scope.allItemDataGridHeight = $scope.detail.allItemsDataGridSource && $scope.detail.allItemsDataGridSource.store.data.length > 4 ? '535px' : 'auto';
                $scope.allItemDataGridHeight = '535px';
            }
        });

        // 特别奇怪监控不了 uib-btn-radio 的值,加上 uib-uncheckable="tabType" 就可以了
        $scope.$watch('tabType', function (newVal, oldValue) {
            if (newVal !== oldValue) {
                if (newVal === 1 && $scope.detail && $scope.isWriteBackUpdate) {
                    $scope.detail.dataGridSource = angular.copy($scope.detail.dataGridSource);
                    $scope.isWriteBackUpdate = false;
                }
            }

        });

        $scope._gridData = [];
        $scope.cellAttachmentDataGirdOptions = {
            columns: [{caption: '序号', dataField: "xh"},
                {
                    caption: '文件名', dataField: "fileName", cellTemplate: function (container, options) {
                        try {
                            $('<a  href="'+options.data.fileUrl +'"  target="_blank" style="cursor: pointer">"' + options.data.fileName + '"</a>&nbsp;&nbsp;')
                                .appendTo(container);
                        }
                        catch (e) {
                            $log.error(e);
                        }
                    }
                },
                {caption: '文件大小', dataField: "size"},
                {caption: '备注信息', dataField: "remarks"},
                {caption: '用户', dataField: "uploadUser"},
                {caption: '操作时间', dataField: "createTime"},
                {
                    caption: '操作', cellTemplate: function (container, options) {
                        try {
                            $('<button type="button"  class="btn btn-in-grid" style="margin-top: -11px;" onclick = "deleteAttach(' + options.data.id + ')"><i class="material-icons middle" style="vertical-align: text-bottom">delete</i>删除</button>&nbsp;&nbsp;')
                                .appendTo(container);
                        }
                        catch (e) {
                            $log.error(e);
                        }
                    }
                }
            ],
            showBorders: true/*,
            editing: {
                mode: "cell",
                allowAdding: false,
                allowUpdating: false,
                allowDeleting: true,

            }*/,
            onInitialized: function (e) {
                $scope.dataGrid = e.component;
            },
            bindingOptions: {
                dataSource: '_gridData'
            }
        };

        window.downLoadAttach = function(id){
            vatReportService.downLoadAttach(id).success(function (res) {
                if(res.result){
                    //导出成功
                }else{
                    SweetAlert.error(res.resultMsg);
                }
            }).error();
        }

        window.deleteAttach = function (id, data) {
            swal({
                    title: "warning!",
                    text: "确定删除该附件？",
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                function (tmpConfirm) {
                    if (tmpConfirm) {
                        vatReportService.deleteAttach(id).success(function (res) {
                            if (res.resultMsg == "success") {
                                $scope.loadAttach();
                            }
                        });

                    }
                });
        }

        //加载附件信息列表
        $scope.loadAttach = function () {
            $scope._gridData = [];
            $scope.activeSheet.pageInfo = $scope.pagingOptions;
            if ($scope.activeSheet.activeRow && $scope.activeSheet.activeCol && $scope.activeSheet.activeTemplateId) {
                //获取附件信息
                vatReportService.loadAttachList($scope.activeSheet).success(function (data) {
                    if (data) {
                        var _xh = 0;
                        for (var i = 0; i < data.length; i++) {
                            /* var _data1 = {
                                 xh : i+1,
                                 fileName : data[i].fileName,
                                 size : data[i].size,
                                 remarks : data[i].remarks,
                                 uploadUser : data[i].uploadUser,
                                 createTime : data[i].createTime,
                                 fileUrl : data[i].

                             }*/
                            data[i].xh = i + 1;
                            $scope._gridData.push(data[i]);
                            _xh = i + 1;
                        }
                        $scope.xh = _xh;
                        //$scope._gridData = data;
                        //$scope.pagingOptions.totalItems = data.totalCount;
                    } else {
                        SweetAlert.error($translate.instant('SystemError'));
                    }

                    //刷新附件列表
                    // $scope.dataGrid.refresh();
                    // dataGrid.refresh();
                }).error(function (error) {
                    SweetAlert.error("附件列表数据加载失败")
                });
            }
        }


        $scope.openAddCellAttachmentDialog = function () {
            $scope.remarks = "";
            $scope.fileNameWrapper = {};
            $scope.fileName = "";
            $('#addCellAttachmentContainer').modal('show');
        }

        $scope.hideCellAttachmentModel = function () {
            $('#addCellAttachmentContainer').modal('hide');
        }


        //选择文档后操作
        var initImportFile = function (fileName) {
            var arr = fileName.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.fileName = fileName.name;
            ///uploadfile($scope.fileNameWrapper, uploadUrl);
            //初始化数据
            /*$scope.selectedMappingList = [];
            //initColumns();
            $scope.ImportErrorTab = false;
            $scope.ImportErrorTag = false;*/
        }

        var refreshAttachData = function (dataSource) {
            $('#addCellAttachmentContainer').modal('hide');
            if ($scope.xh) {
                $scope.xh = $scope.xh + 1;
            } else {
                dataSource.data.xh = 1;
                $scope.xh = 1;
            }
            var _data = {
                xh: $scope.xh,
                fileName: dataSource.data.fileName,
                size: dataSource.data.size,
                remarks: dataSource.data.remarks,
                uploadUser: dataSource.data.uploadUser,
                createTime: dataSource.data.createTime,
                fileUrl: dataSource.data.fileUrl

            }
            $scope._gridData.push(_data);
            // $scope.dataGrid.refresh();
        }
        //上传附件
        var uploadfile = function (file) {
            var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/Report/doUpload';
            if (file) {
                if (!file.$error) {
                    //var tempFileName = PWC.newGuid() + '.dat';
                    var token = $('input[name="__RequestVerificationToken"]').val();
                    Upload.upload({
                        url: uploadUrl,
                        data: {
                            fileName: file.name,
                            file: file,
                            remarks: $scope.cellAttachmentComment,
                            activeRow: $scope.activeSheet.activeRow,
                            activeCol: $scope.activeSheet.activeCol,
                            activeTemplateId: $scope.activeSheet.activeTemplateId
                        },
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken()
                        },
                        __RequestVerificationToken: token,
                        withCredentials: true
                    }).progress(function (evt) {
                        var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                        console.log('progress: ' + progressPercentage + '% ');
                    }).success(function (data, status, headers, config) {
                        if (data.resultMsg) {
                            SweetAlert.error(data.resultMsg)
                            return;
                        }
                        refreshAttachData(data);
                    }).error(function (data, status, headers, config) {
                        $('#addCellAttachmentContainer').modal('hide');
                        SweetAlert.error(status + '错误' + ",上传失败")
                    });
                }
            }
        };

        $scope.$watch('fileNameWrapper', function (newValue, oldValue) {
            if (newValue !== null && newValue !== oldValue) {
                if (newValue.name) {
                    initImportFile(newValue);
                }
            }
        });
        //点击分页
        /*    //刷新页面
            $scope.refreshConfigGrid = function () {
                $http.post('/revenueConf/queryPage',{pageInfo: $scope.pagingOptions}, apiConfig.createVat())
                    .success(function (res) {
                        if (res && res.list) {
                            $scope.pageConfDataSource = res.list;
                            $scope.pagingOptions.totalItems = res.pageInfo.totalCount;
                        }else {
                            SweetAlert.error($translate.instant('SystemError'));
                        }
                    })
            };*/


        //保存按钮
        $scope.uploadCellAttachment = function () {
            uploadfile($scope.fileNameWrapper);
        };


        ///上传成功的回调函数


        (function () {
            //分页的设置
            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 0,  //总数据
                pageSize: 20,  //每页多少条数据
            };
            $scope.hidePanel = hidePanel;
            $scope.isExpand = true;
            $scope.togglePanel = togglePanel;
            $scope.changeTabColor = changeTabColor;
            $scope.changeVisibleDataSourceContainer = changeVisibleDataSourceContainer;
            $scope.confirmEventHandler = confirmEventHandler;
            $scope.addDataSource = addDataSource;
            $scope.selectedDataSourceTabIndex = 1;
            $scope.voucherFilter = enums.formulaDataSourceType.VoucherFilter;
            $scope.InvoiceFilter = enums.formulaDataSourceType.InvoiceFilter;
            $scope.ModelDatasource = enums.formulaDataSourceType.ModelDatasource;
            $scope.closePropover = closePropover;
            $scope.openAcctPropover = openAcctPropover;
            $scope.voucherRangeOptions = voucherRangeOptions;
            $scope.showSelectAccountPop = showSelectAccountPop;
            $scope.voucherRangeConfirm = voucherRangeConfirm;
            $scope.removeVoucherFilterTab = removeVoucherFilterTab;
            $scope.addInvoiceAndVoucher = addInvoiceAndVoucher;
            $scope.checkIfSelectedTab = checkIfSelectedTab;
            $scope.numToExcelChar = PWC.numToExcelChar;
            $scope.voucherRange = {
                voucherKeyword: '',
                filterWay: 1
            };
            $scope.dataSourceOptions = dataGridCommonOptions;
            $scope.allItemsDataSourceOptions = allItemsDataSourceOptions;
            switch ($scope.detail.cellType) {

                case 5:
                    //定义表头样式
                    $scope.dataSourceOptions.customizeColumns = function (columns) {
                        $.each(columns, function (_, element) {
                            //定义表头的模板
                            element.headerCellTemplate = function (header, info) {
                                $('<span>').html(info.column.caption).appendTo(header);
                                $(header).parent().css({
                                    'color': 'white',
                                    'background-color': '#d00',
                                    'font-family': '微软雅黑'
                                })
                            };
                        });
                    };
                    break;
                case 6:
                    $scope.dataSourceOptions.customizeColumns = function (columns) {
                        $.each(columns, function (_, element) {
                            element.headerCellTemplate = function (header, info) {
                                $('<span>').html(info.column.caption).appendTo(header);
                                $(header).parent().css({
                                    'color': 'white',
                                    'background-color': '#d00',
                                    'font-family': '微软雅黑'
                                })
                            };
                        });
                    };
                    break;
            }

            getFormulaList();

            KeyValueConfigService.getAll().success(function (data) {
                $scope.keyValueList = _.map(data, function (config) {
                    return {
                        code: '@' + config.keyCode,
                        name: config.name,
                        description: config.description
                    }
                });
            });
            //加载附件信息
        })();
    }
]);