﻿webservices.factory('vatApproveService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        sample: function () {
            return $http.get('url', apiConfig.createVat());
        },

        startApproveDeploy : function() {
            return $http.post('/approval/deploy', apiConfig.createVat());
        },
        
        commitNewApproval: function (param) {
            return $http.post('/approval/commit',{
            projectId: param.projectId,
            periodDate: param.periodDate
            }, apiConfig.createVat());
        },

        approvalTasks: function (year, month) {
            var assignee='accountant';
            return $http.get('/approval/tasks/'+assignee+"/"+year+"/"+month, apiConfig.createVat());
        },

        getApprovalTemplateInfo:function(templateId){
            return $http.get('/approval/templateInfo/'+templateId, apiConfig.createVat());
        },

        checkTask:function(projectId,period,decide,comment){
            return $http.put('/approval/check/'+projectId+'/'+period+'?decide='+decide+'&comment='+comment, {}, apiConfig.createVat());
        },

        approvalStatus:function(projectId,period){
            return $http.get('/approval/status/'+projectId+'/'+period,apiConfig.createVat({ignoreLoadingBar: true}))
        }
    };
}]);